#include <amxmod.inc>
#include <amxmisc>
#include <superheromod>


// VARIABLES
new gHeroName[]="Paintballs"
new bool:gHaspaintballsPowers[SH_MAXSLOTS+1]
new gpaintballsTimer[SH_MAXSLOTS+1]
new bool:g_isMarked[33][33]
//----------------------------------------------------------------------------------------------
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO Paintballs","2.0","NotUsed")

  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  if ( isDebugOn() ) server_print("Attempting to create paintballs v2 Hero")
  register_cvar("paintballs_level", "0" )
  register_cvar("paintballs_glowtime", "40")
  register_cvar("paintballs_intensity", "80")
  register_cvar("paintballs_tmponly", "0")
  register_cvar("paintballs_randomcolor", "1")
  register_cvar("paintballs_red", "255")
  register_cvar("paintballs_green", "0")
  register_cvar("paintballs_blue", "0")
  //Hero Name- Short Description- Long Description- false=Automatic Powers true=KeyDown powers- Hero level
  shCreateHero(gHeroName, "Paintballs", "Use Paintballs to bring enemys to glow", false, "paintballs_level" )

  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  // INIT
  register_srvcmd("paintballs_init", "paintballs_init")
  shRegHeroInit(gHeroName, "paintballs_init")
  register_event("ResetHUD","newRound","b")
  register_event("Damage", "paintballs_damage", "b", "2!0")
  register_srvcmd("paintballs_loop", "paintballs_loop")
  set_task(1.0,"paintballs_loop",0,"",0,"b")
}
//----------------------------------------------------------------------------------------------
public newRound(id, victim)
{
if (g_isMarked[id][victim] == true)
set_user_rendering(victim,  kRenderFxNone, 0, 0, 0, kRenderNormal, 0)
}
//----------------------------------------------------------------------------------------------
public paintballs_init()
{
  new temp[128]
  // First Argument is an id
  read_argv(1, temp, 5)
  new id = strtonum(temp)

   // 2nd Argument is 0 or 1 depending on whether the id has Paintballs power
  read_argv(2, temp, 5)
  new hasPowers = strtonum(temp)

  if(hasPowers)
      gHaspaintballsPowers[id] = true
  else
      gHaspaintballsPowers[id] = false
}
//----------------------------------------------------------------------------------------------
public paintballs_damage(id)
{
  new attacker = get_user_attacker(id)

  if(!shModActive() || !gHaspaintballsPowers[attacker])
      return PLUGIN_CONTINUE
  if(is_user_alive(id) && id != attacker)
   {
      if(gPlayerUltimateUsed[attacker])
      {
         playSoundDenySelect(attacker)
         return PLUGIN_HANDLED
      }
      gpaintballsTimer[id] = get_cvar_num("paintballs_glowtime") + 1
      paintballs_power(attacker, id)
      ultimateTimer(attacker, get_cvar_num("paintballs_cooldown") * 1.0)
      }
  return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public paintballs_power(id,victim)
{
  new red
  new green
  new blue
  new clip
  new ammo
  new intensity=get_cvar_num("paintballs_intensity")
  new wpn_id=get_user_weapon(id, clip, ammo)
  if (( wpn_id == CSW_TMP) && (get_cvar_num("paintballs_tmponly")==1))
    {
    if (get_cvar_num("paintballs_randomcolor")==1)
      {
      red=random_num(0,255)
      green=random_num(0,255)
      blue=random_num(0,255)
      set_user_rendering(victim, kRenderFxGlowShell, red, green, blue, kRenderNormal, intensity)
      g_isMarked[id][victim] = true
      }
    else
      {
      red=get_cvar_num("paintballs_red")
      green=get_cvar_num("paintballs_green")
      blue=get_cvar_num("paintballs_blue")
      set_user_rendering(victim, kRenderFxGlowShell, red, green, blue, kRenderNormal, intensity)
      g_isMarked[id][victim] = true
      }
    }
  else
    {
    if(get_cvar_num("paintballs_tmponly")==0)
        {
        if (get_cvar_num("paintballs_randomcolor")==1)
        {
        red=random_num(0,255)
        green=random_num(0,255)
        blue=random_num(0,255)
        set_user_rendering(victim, kRenderFxGlowShell, red, green, blue, kRenderNormal, intensity)
        g_isMarked[id][victim] = true
        }
        else
        {
        red=get_cvar_num("paintballs_red")
        green=get_cvar_num("paintballs_green")
        blue=get_cvar_num("paintballs_blue")
        set_user_rendering(victim, kRenderFxGlowShell, red, green, blue, kRenderNormal, intensity)
        g_isMarked[id][victim] = true
        }
    }
  }
}
//----------------------------------------------------------------------------------------------
public paintballs_unglow(id, victim) {
  set_user_rendering(victim, kRenderFxGlowShell, 0, 0, 0, kRenderNormal, 0)
  g_isMarked[id][victim] = true
}
//----------------------------------------------------------------------------------------------
public paintballs_loop()
{
   for(new id = 1; id <= SH_MAXSLOTS; id++)
   {
      for(new victim = 1; victim <= SH_MAXSLOTS; victim++)
      {
         if(g_isMarked[id][victim])
         {
            if(gpaintballsTimer[victim] > 0)
            {
            gpaintballsTimer[victim]--
            }
            else
            {
            gpaintballsTimer[victim]--
            paintballs_unglow(id, victim)
            }

            }
         }
      }
   }
//----------------------------------------------------------------------------------------------
