#include <amxmod.inc>
#include <superheromod.inc>

// stalker!
// CVARS
// stalker_level


// VARIABLES
new gHeroName[]="Stalker"
new bool:gHasStalkerPower[SH_MAXSLOTS+1]
//----------------------------------------------------------------------------------------------
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO Stalker","1.0","Prowler")

  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  if ( isDebugOn() ) server_print("Attempting to create stalker Hero")
  register_cvar("stalker_level", "9" )
  shCreateHero(gHeroName, "Stalker-Mode", "Faster,Less Visible", false, "stalker_level")
  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  register_event("CurWeapon","changeWeapon","be","1=1")



  register_srvcmd("stalker_init", "stalker_init")
  shRegHeroInit(gHeroName, "stalker_init")

  register_srvcmd("stalker_loop", "stalker_loop")
  set_task(1.0,"stalker_loop",0,"",0,"b") //forever loop

  shSetMaxSpeed(gHeroName, "stalker_speed", "[29]" )
  register_cvar("stalker_speed", "400" )

}
//----------------------------------------------------------------------------------------------
public stalker_init()
{
  new temp[128]
  // First Argument is an id
  read_argv(1,temp,5)
  new id=str_to_num(temp)

  // 2nd Argument is 0 or 1 depending on whether the id has iron man powers
  read_argv(2,temp,5)
  new hasPowers=str_to_num(temp)

  gHasStalkerPower[id]=(hasPowers!=0)
  changeWeapon(id)

  if ( !gHasStalkerPower[id]  && is_user_connected(id) ) {
    shRemSpeedPower(id)
    set_user_rendering(id,kRenderFxGlowShell,0,0,0,kRenderTransAlpha,255)
    }
}
//----------------------------------------------------------------------------------------------
public stalker_loop()
{
 for ( new id=1; id<=SH_MAXSLOTS; id++ )
 {
   if ( gHasStalkerPower[id] && is_user_alive(id)  )
    {
      set_user_rendering(id,kRenderFxGlowShell,0,0,0,kRenderTransAlpha,20)
    }
  }
}
//----------------------------------------------------------------------------------------------
public changeWeapon(id)
{
 if ( !gHasStalkerPower[id] || !shModActive() || !is_user_connected(id) || !is_user_alive(id)) return

 if ( gHasStalkerPower[id] && is_user_alive(id)) {
 new primary = (1<<29)|(1<<6)
 if ( primary & ( 1 << read_data(2) ) ) return
 else
 engclient_cmd(id,"weapon_knife")
 shResetSpeed(id)
 }
}
//----------------------------------------------------------------------------------------------
